.check_package:
  before_script:
    - |
      function check_pkg() {
        if [[ $PKG == "gradlew" ]];
        then
          chmod +x gradlew
          export PKG="./gradlew"
        fi
      }
    - |
      function dependency() {
        export CI_SONAR_PROJECT_NAME=$(echo $CI_PROJECT_NAMESPACE | cut -d "/" -f 2)
        export JAVA_PARAMS="-PSONAR_TOKEN=$GIT_SONAR_TOKEN -PSONAR_HOST_URL=$GIT_SONAR_HOST_URL -PSONAR_PROJECT_NAME=$CI_SONAR_PROJECT_NAME.$CI_PROJECT_NAME $NEXUS_PARAM -Dsonar.exclusions=**/*.java $PROXY" 
      }
      function set_gradle_home() {
        export GRADLE_USER_HOME=`pwd`/.gradle
      }


variables:
  JAVA_IMAGE_SONAR: harbor.abbos92.uz/java/gradle:jdk-17-alpine-cert

sonarqube:
  image: $JAVA_IMAGE_SONAR
  cache:
    key: gradle-caches
    paths:
      - .gradle/wrapper
      - .gradle/caches
    policy: pull-push
  extends:
    - .check_package
  stage: prepare
  rules:
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "develop"
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "/^feature/.*$/"
    - if: $CI_COMMIT_REF_SLUG == "main"
    - if: $CI_COMMIT_REF_SLUG == "develop"
    - if: $CI_COMMIT_REF_NAME =~ /^feature/ 
  script:
    - set_gradle_home
    - check_pkg
    - dependency
    - $PKG sonarqube $JAVA_PARAMS
  tags:
    - "stable" 
